## Calculate Mantel statistic for each life stage, with and without siblings

# Load packages
library(reshape)
require(ecodist)
#!#!#!#!#!

## Read data
dist <- read.csv("Pond_Dist.csv")[,3]
am.n.sib<-read.csv("amac_data.csv",header=T,sep=",")
am.sib<-read.csv("amac_data_all.csv",header=T,sep=",")

am.n.sib.long <- melt(am.n.sib,id=c("pond","measure"),variable_name="stage")
am.sib.long <- melt(am.sib,id=c("pond","measure"),variable_name="stage")

n.sib.Fst<-am.n.sib.long[which(am.n.sib.long$measure=="Fst"),]
sib.Fst<-am.sib.long[which(am.sib.long$measure=="Fst"),]

n.sib.Dc <- am.n.sib.long[which(am.n.sib.long$measure=="Dc"),]
sib.Dc <- am.sib.long[which(am.sib.long$measure=="Dc"),]

# Fst data
n.sib.A <- n.sib.Fst[which(n.sib.Fst$stage=="adult"),]$value
n.sib.E <- n.sib.Fst[which(n.sib.Fst$stage=="embryo"),]$value
n.sib.L <- n.sib.Fst[which(n.sib.Fst$stage=="larvae"),]$value

sib.A <- sib.Fst[which(sib.Fst$stage=="adult"),]$value
sib.E <- sib.Fst[which(sib.Fst$stage=="embryo"),]$value
sib.L <- sib.Fst[which(sib.Fst$stage=="larvae"),]$value

# Dc data
n.sib.A_Dc <- n.sib.Dc[which(n.sib.Dc$stage=="adult"),]$value
n.sib.E_Dc <- n.sib.Dc[which(n.sib.Dc$stage=="embryo"),]$value
n.sib.L_Dc <- n.sib.Dc[which(n.sib.Dc$stage=="larvae"),]$value

sib.A_Dc <- sib.Dc[which(sib.Dc$stage=="adult"),]$value
sib.E_Dc <- sib.Dc[which(sib.Dc$stage=="embryo"),]$value
sib.L_Dc <- sib.Dc[which(sib.Dc$stage=="larvae"),]$value


DATA<-list(n.sib.A,n.sib.E,n.sib.L,sib.A,sib.E,sib.L)
DATA.names<-list("n.sib.A","n.sib.E","n.sib.L","sib.A","sib.E","sib.L")
RESULTS<-matrix(nrow=length(DATA),ncol=2)

DATA_Dc<-list(n.sib.A_Dc,n.sib.E_Dc,n.sib.L_Dc,sib.A_Dc,sib.E_Dc,sib.L_Dc)
DATA.names_Dc<-list("n.sib.A_Dc","n.sib.E_Dc","n.sib.L_Dc","sib.A_Dc","sib.E_Dc","sib.L_Dc")
RESULTS_Dc<-matrix(nrow=length(DATA_Dc),ncol=2)

for (i in 1:(length(DATA))){
  Y<-DATA[[i]]
  Y_Dc <- DATA_Dc[[i]]
  dat<-na.omit(as.data.frame(cbind(Y,dist)))
  dat_Dc <- na.omit(as.data.frame(cbind(Y_Dc,dist)))
  
  RESULTS[i,] <- mantel(Y~dist,data=dat,nperm=100000)[c(1,2)] ## Mantel
  RESULTS_Dc[i,] <- mantel(Y_Dc~dist,data=dat_Dc,nperm=100000)[c(1,2)] ## Mantel
}
row.names(RESULTS)<-DATA.names
colnames(RESULTS)<-c("mantelr","pval")
RESULTS

row.names(RESULTS_Dc)<-DATA.names_Dc
colnames(RESULTS_Dc)<-c("mantelr","pval")
RESULTS_Dc


